=== debian/changelog ===
vecgeom (1.1.18+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #988526)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Mon, 20 Dec 2021 22:54:19 +0100
