=== debian/control ===
Source: vecgeom
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libembree-dev [any-amd64],
 libxerces-c-dev,
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
 veccore-dev,
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/vecgeom
Vcs-Git: https://salsa.debian.org/science-team/vecgeom.git
Homepage: https://gitlab.cern.ch/VecGeom/VecGeom

Package: vecgeom-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 veccore-dev,
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
 libembree-dev [any-amd64],
Description: vectorized geometry library for particle-detector simulation
 VecGeom is a geometry modeller library with hit-detection features as needed
 by particle detector simulation at the LHC and beyond.
