=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Set to ON to build with optimizations
BUILD_OPTIMIZED=OFF

# Use Vc only on amd64, arm, arm64 and i386, else Scalar
ifeq (,$(filter $(DEB_TARGET_ARCH),amd64 arm arm64 i386))
	BACKEND=Scalar
else
	BACKEND=Vc
	ifeq ($(BUILD_OPTIMIZED),ON)
		VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=auto
	else
		VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=generic
	endif
endif

# Use Embree only on any-amd64
ifeq (,$(filter $(DEB_TARGET_ARCH),amd64))
	EMBREE=OFF
else
	EMBREE=ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=17 \
		-DBUILD_TESTING=OFF \
		-DVECGEOM_VECTOR=native \
		-DGDML=ON \
		-DEMBREE=$(EMBREE) \
		-DBACKEND=$(BACKEND) $(VC_TARGET_ARCHITECTURE) \
		-DBUILD_OPTIMIZED=$(BUILD_OPTIMIZED)
