=== debian/watch ===
version=4
opts="dversionmangle=s%\+dfsg\d*$%%,repacksuffix=+dfsg" \
    https://gitlab.cern.ch/VecGeom/VecGeom/tags?sort=updated_desc archive/v?@ANY_VERSION@/.*@ARCHIVE_EXT@
